import * as i0 from '@angular/core';
import { Injectable, Component, NgModule, InjectionToken, PLATFORM_ID, Inject, Input, Optional, SkipSelf } from '@angular/core';
import { isPlatformBrowser } from '@angular/common';

class MyLibService {
    constructor() { }
}
MyLibService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: MyLibService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MyLibService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: MyLibService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: MyLibService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class MyLibComponent {
    constructor() { }
    ngOnInit() {
    }
}
MyLibComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: MyLibComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
MyLibComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.3", type: MyLibComponent, selector: "lib-my-lib", ngImport: i0, template: `
    <p>
      my-lib works!
    </p>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: MyLibComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-my-lib', template: `
    <p>
      my-lib works!
    </p>
  ` }]
        }], ctorParameters: function () { return []; } });

// import { RampComponent } from './ramp/ramp.component'
class MyLibModule {
}
MyLibModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: MyLibModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MyLibModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.3", ngImport: i0, type: MyLibModule, declarations: [MyLibComponent], exports: [MyLibComponent] });
MyLibModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: MyLibModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: MyLibModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        MyLibComponent
                    ],
                    imports: [],
                    exports: [
                        MyLibComponent
                    ]
                }]
        }] });

/* Create a new injection token for injecting the window into a component. */
const WINDOW = new InjectionToken('WindowToken');
/* Define abstract class for obtaining reference to the global window object. */
class WindowRef {
    get nativeWindow() {
        throw new Error('Not implemented.');
    }
}
/* Define class that implements the abstract class and returns the native window object. */
class BrowserWindowRef extends WindowRef {
    constructor() {
        super();
    }
    get nativeWindow() {
        return window;
    }
}
/* Create an factory function that returns the native window object. */
function windowFactory(browserWindowRef, platformId) {
    if (isPlatformBrowser(platformId)) {
        return browserWindowRef.nativeWindow;
    }
    return new Object();
}
/* Create a injectable provider for the WindowRef token that uses the BrowserWindowRef class. */
const browserWindowProvider = {
    provide: WindowRef,
    useClass: BrowserWindowRef
};
/* Create an injectable provider that uses the windowFactory function for returning the native window object. */
const windowProvider = {
    provide: WINDOW,
    useFactory: windowFactory,
    deps: [WindowRef, PLATFORM_ID]
};
/* Create an array of providers. */
const WINDOW_PROVIDERS = [
    browserWindowProvider,
    windowProvider
];

class RampComponent {
    constructor(window) {
        this.window = window;
    }
    ngOnInit() {
        window.ramp = window.ramp || {};
        window.ramp.que = window.ramp.que || [];
        window.ramp.passiveMode = true;
        window._pwRampComponentLoaded = window._pwRampComponentLoaded || false;
        const oopUnits = [
            'trendi_slideshow',
            'trendi_video',
            'site_skin',
            'flex_leaderboard',
            'top_rail',
            'right_rail',
            'bottom_rail',
            'left_rail'
        ];
        // if (window._pwRampComponentLoaded)
        //   return;
        window._pwRampComponentLoaded = true;
        window.ramp.config = `https://config.playwire.com/${this.publisherId}/v2/websites/${this.id}/banner.json`;
        const configScript = document.createElement("script");
        // configScript.src = `https://cdn.intergient.com/${publisherId}/${id}/ramp.js`;
        configScript.src = 'https://cdn.intergient.com/ramp_core.js';
        document.head.appendChild(configScript);
        window.ramp.que.push(() => {
            window.ramp.addUnits([
                { type: 'trendi_slideshow' },
                { type: 'trendi_video' },
                { type: 'site_skin' },
                { type: 'flex_leaderboard' },
                { type: 'top_rail' },
                { type: 'right_rail' },
                { type: 'bottom_rail' },
                { type: 'left_rail' },
                // {type: 'behind_page'},
                // {type: 'in_image'},
                // {type: 'above_page'},
                // {type: 'in_content'},
                // {type: 'inimg'},
                // {type: 'skin'}
            ])
                .then(() => {
                window.ramp.displayUnits();
            });
        });
    }
}
RampComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: RampComponent, deps: [{ token: WINDOW }], target: i0.ɵɵFactoryTarget.Component });
RampComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.3", type: RampComponent, selector: "ramp", inputs: { publisherId: "publisherId", id: "id" }, ngImport: i0, template: "<p>ramp works!</p>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: RampComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ramp', template: "<p>ramp works!</p>" }]
        }], ctorParameters: function () {
        return [{ type: Window, decorators: [{
                        type: Inject,
                        args: [WINDOW]
                    }] }];
    }, propDecorators: { publisherId: [{
                type: Input
            }], id: [{
                type: Input
            }] } });

class RampModule {
}
RampModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: RampModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
RampModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.3", ngImport: i0, type: RampModule, declarations: [RampComponent], exports: [RampComponent] });
RampModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: RampModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: RampModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        RampComponent
                    ],
                    imports: [],
                    exports: [
                        RampComponent
                    ]
                }]
        }] });

class RampUnitComponent {
    constructor() {
    }
    ngOnInit() {
        window.ramp.que.push(() => {
            window.ramp.addUnits([
                {
                    type: this.type,
                    selectorId: this.selectorId
                }
            ]).catch((e) => {
                console.warn(e);
            }).finally(() => {
                window.ramp.displayUnits();
            });
        });
    }
}
RampUnitComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: RampUnitComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
RampUnitComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.3", type: RampUnitComponent, selector: "ramp-unit", inputs: { type: "type", selectorId: "selectorId", cssClass: "cssClass" }, ngImport: i0, template: "<div [attr.data-pw-desk]=\"type\" [attr.id]=\"selectorId\" [attr.class]=\"cssClass\"></div>\n\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: RampUnitComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ramp-unit', template: "<div [attr.data-pw-desk]=\"type\" [attr.id]=\"selectorId\" [attr.class]=\"cssClass\"></div>\n\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { type: [{
                type: Input
            }], selectorId: [{
                type: Input
            }], cssClass: [{
                type: Input
            }] } });

class RampUnitModule {
}
RampUnitModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: RampUnitModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
RampUnitModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.3", ngImport: i0, type: RampUnitModule, declarations: [RampUnitComponent], exports: [RampUnitComponent] });
RampUnitModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: RampUnitModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: RampUnitModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        RampUnitComponent
                    ],
                    imports: [],
                    exports: [
                        RampUnitComponent
                    ]
                }]
        }] });

class CoreModule {
    constructor(parentModule) {
        if (parentModule) {
            throw new Error('CoreModule is already loaded. Import it in the AppModule only');
        }
    }
    static forRoot() {
        return {
            ngModule: CoreModule,
            providers: []
        };
    }
}
CoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: CoreModule, deps: [{ token: CoreModule, optional: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.NgModule });
CoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.3", ngImport: i0, type: CoreModule });
CoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: CoreModule, providers: [
        WINDOW_PROVIDERS
    ] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: CoreModule, decorators: [{
            type: NgModule,
            args: [{
                    providers: [
                        WINDOW_PROVIDERS
                    ]
                }]
        }], ctorParameters: function () {
        return [{ type: CoreModule, decorators: [{
                        type: Optional
                    }, {
                        type: SkipSelf
                    }] }];
    } });

/*
 * Public API Surface of pw-angular-component
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CoreModule, MyLibComponent, MyLibModule, MyLibService, RampComponent, RampModule, RampUnitComponent, RampUnitModule };
//# sourceMappingURL=playwire-pw-angular-component.mjs.map
